#include "stdafx.h"
#include "ModifyHatch.h"


CModifyHatch::CModifyHatch()
{
}


CModifyHatch::~CModifyHatch()
{
}

void CModifyHatch::ModifyHatch()
{
	ads_name eName;
	ads_point adsPickPoint;
	AcGePoint3d ptPick;
	int nRet = acedEntSel(_T("\nSelect First Line "), eName, adsPickPoint);
	if (nRet != RTNORM)
	{
		return;
	}
	ptPick = asPnt3d(adsPickPoint);
	AcDbObjectId id1;
	Acad::ErrorStatus es = acdbGetObjectId(id1, eName);
	if (es != Acad::eOk)
	{
		return;
	}
	nRet = acedEntSel(_T("\nSelect Second Line "), eName, adsPickPoint);
	if (nRet != RTNORM)
	{
		return;
	}
	ptPick = asPnt3d(adsPickPoint);
	AcDbObjectId id2;
	es = acdbGetObjectId(id2, eName);
	if (es != Acad::eOk)
	{
		return;
	}
	AcDbObjectId		hatchId, hid;
	AcDbObjectIdArray	asscHids;
	int					loopindex;
	Adesk::Int32		looptype;
	bool hatch = FindHatchObjs(id1, hatchId, loopindex, looptype, asscHids);
	if (!hatch)
	{
		hatch = FindHatchObjs(id2, hatchId, loopindex, looptype, asscHids);
	}
	AcDbObjectId id;
	SetNewHatchBoundary(id1, hatchId, loopindex, looptype, asscHids, true,id);
}
bool CModifyHatch::FindHatchObjs(const AcDbObjectId& id, AcDbObjectId& hid, int& loopindex, Adesk::Int32& looptype, AcDbObjectIdArray& asscids)
{
	AcDbEntity			*ent;
	AcDbObjectIdArray	ids;
	bool				fhatch = false;

	if (acdbOpenAcDbEntity(ent, id, AcDb::kForRead) != Acad::eOk)
	{
		return false;
	}

	const AcDbVoidPtrArray *reacs = ent->reactors();

	if (ent->close()!=Acad::eOk) return false;

	if (reacs == NULL) return false;

	for (int i = 0; i < reacs->length(); i++)
	{
		if (!acdbIsPersistentReactor(reacs->at(i))) continue;

		hid = acdbPersistentReactorObjectId(reacs->at(i));

		if (acdbOpenAcDbEntity(ent, hid, AcDb::kForRead) != Acad::eOk) continue;

		if (ent->isKindOf(AcDbHatch::desc()))
		{
			AcDbHatch *hatch = AcDbHatch::cast(ent);
			if (hatch->associative())
			{
				for (int j = 0, nls = hatch->numLoops(); j < nls; j++)
				{
					hatch->getAssocObjIdsAt(j, ids);

					if (!ids.contains(id)) continue;

					asscids = ids;
					loopindex = j;
					looptype = hatch->loopTypeAt(loopindex);
					fhatch = true;

					break;
				}
			}
		}

		if (ent->close() != Acad::eOk) return false;

		if (fhatch) break;
	}

	return fhatch;
}
bool CModifyHatch::SetNewHatchBoundary(const AcDbObjectId& nid, const AcDbObjectId& hid, int loopindex, Adesk::Int32 looptype, AcDbObjectIdArray& ids, bool bEval, const AcDbObjectId& idObjCham4)
{
	AcDbEntity	*ent;
	bool		ret = true;
	if (acdbOpenAcDbEntity(ent, hid, AcDb::kForWrite) != Acad::eOk)
	{
		return false;
	}
	AcDbHatch		*hatch = AcDbHatch::cast(ent);
	Adesk::Int32	dtype;

	if (nid != AcDbObjectId::kNull && ids.contains(nid) == Adesk::kFalse)
	{
		ids.append(nid);
	}

	if (idObjCham4 != AcDbObjectId::kNull && ids.contains(idObjCham4) == Adesk::kFalse)
	{
		ids.append(idObjCham4);
	}

	hatch->removeLoopAt(loopindex);
	hatch->setAssociative(Adesk::kTrue);

	dtype = (looptype & AcDbHatch::kExternal) ?
		AcDbHatch::kExternal : AcDbHatch::kDefault;

	if (bEval == true || nid != AcDbObjectId::kNull)
	{
		ret = hatch->insertLoopAt(loopindex, dtype, ids) == Acad::eOk;
		if (ret)
		{
			hatch->evaluateHatch();
		}
	}

	if (ent->close() != Acad::eOk)
	{
		return false;
	}
	if (!ret)
	{
		return ret;
	}

	AcDbObject *obj;

	for (int i = 0; i < ids.length(); i++)
	{
		if (acdbOpenAcDbObject(obj, ids[i], AcDb::kForWrite) == Acad::eOk)
		{
			obj->addPersistentReactor(hid);
			if (ent->close() != Acad::eOk)
			{
				return false;
			}
		}
	}
	return true;
}